# Yahoo! UI Library

### autocomplete 3.3.0

Yahoo! UI Library > autocomplete > AutoCompleteBase
Search:
Filters Show Private Show Protected Show Deprecated

## Class AutoCompleteBase

Extension that provides core autocomplete logic (but no UI implementation) for a text input field or textarea.

The `AutoCompleteBase` class provides events and attributes that abstract away core autocomplete logic and configuration, but does not provide a widget implementation or suggestion UI. For a prepackaged autocomplete widget, see `AutoCompleteList`.

This extension cannot be instantiated directly, since it doesn't provide an actual implementation. It's intended to be mixed into a `Y.Base`-based class or widget.

`Y.Widget`-based example:

    YUI().use('autocomplete-base', 'widget', function (Y) {
      var MyAC = Y.Base.create('myAC', Y.Widget, [Y.AutoCompleteBase], {
        // Custom prototype methods and properties.
      }, {
        // Custom static methods and properties.
      });

      // Custom implementation code.
    });

`Y.Base`-based example:

    YUI().use('autocomplete-base', function (Y) {
      var MyAC = Y.Base.create('myAC', Y.Base, [Y.AutoCompleteBase], {
        initializer: function () {
          this._bindUIACBase();
          this._syncUIACBase();
        },

        // Custom prototype methods and properties.
      }, {
        // Custom static methods and properties.
      });

      // Custom implementation code.
    });

### Properties

#### _YQL_SOURCE_REGEX - `protected RegExp`

Regular expression used to determine whether a String source is a YQL query.

### Methods

#### _afterValueChange

`protected void _afterValueChange ( e )`
Handles change events for the `value` attribute.

Parameters:
  `e <EventFacade>`

#### _bindUIACBase

`protected void _bindUIACBase ( )`
Attaches event listeners and behaviors.

#### _createArraySource

`protected Object _createArraySource ( source )`
Creates a DataSource-like object that simply returns the specified array as a response. See the `source` attribute for more details.

Parameters:
  `source <Array>`

Returns: `Object`
  DataSource-like object.

#### _createFunctionSource

`protected Object _createFunctionSource ( source )`
Creates a DataSource-like object that passes the query to a custom-defined function, which is expected to return an array as a response. See the `source` attribute for more details.

Parameters:
  `source <Function>` Function that accepts a query parameter and returns an array of results.

Returns: `Object`
  DataSource-like object.

#### _createIOSource

`protected Object _createIOSource ( source )`
Creates a DataSource-like object that uses `Y.io` as a source. See the `source` attribute for more details.

Parameters:
  `source <String>` URL.

Returns: `Object`
  DataSource-like object.

#### _createJSONPSource

`protected Object _createJSONPSource ( source )`
Creates a DataSource-like object that uses the specified JSONPRequest instance as a source. See the `source` attribute for more details.

Parameters:
  `source <JSONPRequest|String>` URL string or JSONPRequest instance.

Returns: `Object`
  DataSource-like object.

#### _createObjectSource

`protected Object _createObjectSource ( source )`
Creates a DataSource-like object that looks up queries as properties on the specified object, and returns the found value (if any) as a response. See the `source` attribute for more details.

Parameters:
  `source <Object>`

Returns: `Object`
  DataSource-like object.

#### _createStringSource

`protected Object _createStringSource ( source )`
Creates a DataSource-like object that calls the specified URL or executes the specified YQL query for results. If the string starts with "select ", "use ", or "set " (case-insensitive), it's assumed to be a YQL query; otherwise, it's assumed to be a URL (which may be absolute or relative). URLs containing a "{callback}" placeholder are assumed to be JSONP URLs; all others will use XHR. See the `source` attribute for more details.

Parameters:
  `source <String>` URL or YQL query.

Returns: `Object`
  DataSource-like object.

#### _createYQLSource

`protected Object _createYQLSource ( source )`
Creates a DataSource-like object that uses the specified YQL query string to create a YQL-based source. See the `source` attribute for details. If no `resultListLocator` is defined, this method will set a best-guess locator that might work for many typical YQL queries.

Parameters:
  `source <String>` YQL query.

Returns: `Object`
  DataSource-like object.

#### _defaultYQLLocator

`protected Array _defaultYQLLocator ( response )`
Default resultListLocator used when a string-based YQL source is set and the implementer hasn't already specified one.

Parameters:
  `response <Object>` YQL response object.

#### _defClearFn

`protected void _defClearFn ( )`
Default `clear` event handler. Sets the `results` property to an empty array and `query` to null.

#### _defQueryFn

`protected void _defQueryFn ( e )`
Default `query` event handler. Sets the `query` property and sends a request to the source if one is configured.

Parameters:
  `e <EventFacade>`

#### _defResultsFn

`protected void _defResultsFn ( e )`
Default `results` event handler. Sets the `results` property to the latest results.

Parameters:
  `e <EventFacade>`

#### _destructorACBase

`protected void _destructorACBase ( )`
Detaches AutoCompleteBase event listeners.

#### _functionValidator

`protected void _functionValidator ( value )`
Returns `true` if value is either a function or `null`.

Parameters:
  `value <Function|null>` Value to validate.

#### _getObjectValue

`protected mixed _getObjectValue ( obj , path )`
Faster and safer alternative to Y.Object.getValue(). Doesn't bother casting the path to an array (since we already know it's an array) and doesn't throw an error if a value in the middle of the object hierarchy is neither `undefined` nor an object.

Parameters:
  `obj <Object>`
  `path <Array>`

Returns: `mixed`
  Located value, or `undefined` if the value was not found at the specified path.

#### _jsonpFormatter

`protected String _jsonpFormatter ( url , proxy , query )`
URL formatter passed to `JSONPRequest` instances.

Parameters:
  `url <String>`
  `proxy <String>`
  `query <String>`

Returns: `String`
  Formatted URL

#### _onInputBlur

`protected void _onInputBlur ( e )`
Handles `blur` events on the input node.

Parameters:
  `e <EventFacade>`

#### _onInputValueChange

`protected void _onInputValueChange ( e )`
Handles `valueChange` events on the input node and fires a `query` event when the input value meets the configured criteria.

Parameters:
  `e <EventFacade>`

#### _onResponse

`protected void _onResponse ( e )`
Handles source responses and fires the `results` event.

Parameters:
  `e <EventFacade>`

#### _parseResponse

`protected void _parseResponse ( query , response , data )`
Parses result responses, performs filtering and highlighting, and fires the `results` event.

Parameters:
  `query <String>` Query that generated these results.
  `response <Object>` Response containing results.
  `data <Object>` Raw response data.

#### _parseValue

`protected String|null _parseValue ( value )`

Returns the query portion of the specified input value, or `null` if there is no suitable query within the input value.

If a query delimiter is defined, the query will be the last delimited part of of the string.

Parameters:
  `value <String>` Input value from which to extract the query.

Returns: `String|null`
  query

#### _setLocator

`protected Function|null _setLocator ( locator )`
Setter for locator attributes.

Parameters:
  `locator <Function|String|null>`

#### _setRequestTemplate

`protected Function|null _setRequestTemplate ( template )`
Setter for the `requestTemplate` attribute.

Parameters:
  `template <Function|String|null>`

#### _setResultFilters

`protected Array _setResultFilters ( filters )`
Setter for the `resultFilters` attribute.

Parameters:
  `filters <Array|Function|String|null>` `null`, a filter function, an array of filter functions, or a string or array of strings representing the names of methods on `Y.AutoCompleteFilters`.

Returns: `Array`
  Array of filter functions (empty if filters is `null`).

#### _setResultHighlighter

`protected Function|null _setResultHighlighter ( highlighter )`
Setter for the `resultHighlighter` attribute.

Parameters:
  `highlighter <Function|String|null>` `null`, a highlighter function, or a string representing the name of a method on `Y.AutoCompleteHighlighters`.

#### _setSource

`protected DataSource|Object _setSource ( source )`
Setter for the `source` attribute. Returns a DataSource or a DataSource-like object depending on the type of source.

Parameters:
  `source <Array|DataSource|Object|String>` AutoComplete source. See the `source` attribute for details.

#### _sourceSuccess

`protected void _sourceSuccess ( data , request )`
Shared success callback for non-DataSource sources.

Parameters:
  `data <mixed>` Response data.
  `request <Object>` Request object.

#### _syncBrowserAutocomplete

`protected void _syncBrowserAutocomplete ( )`
Synchronizes the UI state of the `allowBrowserAutocomplete` attribute.

#### _syncUIACBase

`protected void _syncUIACBase ( )`
Synchronizes the UI state of the `inputNode`.

#### _updateValue

`protected void _updateValue ( newVal )`

Updates the query portion of the `value` attribute.

If a query delimiter is defined, the last delimited portion of the input value will be replaced with the specified value.

Parameters:
  `newVal <String>` New value.

#### sendRequest

`void sendRequest ( query , requestTemplate )`

Sends a request to the configured source. If no source is configured, this method won't do anything.

Usually there's no reason to call this method manually; it will be called automatically when user input causes a `query` event to be fired. The only time you'll need to call this method manually is if you want to force a request to be sent when no user input has occurred.

Parameters:
  `query <String>` (optional) Query to send. If specified, the `query` attribute will be set to this query. If not specified, the current value of the `query` attribute will be used.
  `requestTemplate <Function>` (optional) Request template function. If not specified, the current value of the `requestTemplate` attribute will be used.

Chainable: This method is chainable.

### Events

#### allowBrowserAutocompleteChange

`allowBrowserAutocompleteChange ( event )`
Fires when the value for the configuration attribute 'allowBrowserAutocomplete' is changed. You can listen for the event using the on method if you wish to be notified before the attribute's value has changed, or using the after method if you wish to be notified after the attribute's value has changed.

Parameters:
  `event <Event.Facade>` An Event Facade object with the following attribute specific properties added:
  prevVal
    The value of the attribute, prior to it being set
  newVal
    The value the attribute is to be set to
  attrName
    The name of the attribute being set
  subAttrName
    If setting a property within the attribute's value, the name of the sub-attribute property being set

#### allowTrailingDelimiterChange

`allowTrailingDelimiterChange ( event )`
Fires when the value for the configuration attribute 'allowTrailingDelimiter' is changed. You can listen for the event using the on method if you wish to be notified before the attribute's value has changed, or using the after method if you wish to be notified after the attribute's value has changed.

Parameters:
  `event <Event.Facade>` An Event Facade object with the following attribute specific properties added:
  prevVal
    The value of the attribute, prior to it being set
  newVal
    The value the attribute is to be set to
  attrName
    The name of the attribute being set
  subAttrName
    If setting a property within the attribute's value, the name of the sub-attribute property being set

#### clear

`clear ( e )`
Fires after the query has been completely cleared or no longer meets the minimum query length requirement.

Parameters:
  `e <EventFacade>` Event facade with the following additional properties:
  prevVal (String)
    Value of the query before it was cleared.

Preventable: This event is preventable by method e.preventDefault(). The default function executed by this event is _defClearFn.

#### inputNodeChange

`inputNodeChange ( event )`
Fires when the value for the configuration attribute 'inputNode' is changed. You can listen for the event using the on method if you wish to be notified before the attribute's value has changed, or using the after method if you wish to be notified after the attribute's value has changed.

Parameters:
  `event <Event.Facade>` An Event Facade object with the following attribute specific properties added:
  prevVal
    The value of the attribute, prior to it being set
  newVal
    The value the attribute is to be set to
  attrName
    The name of the attribute being set
  subAttrName
    If setting a property within the attribute's value, the name of the sub-attribute property being set

#### maxResultsChange

`maxResultsChange ( event )`
Fires when the value for the configuration attribute 'maxResults' is changed. You can listen for the event using the on method if you wish to be notified before the attribute's value has changed, or using the after method if you wish to be notified after the attribute's value has changed.

Parameters:
  `event <Event.Facade>` An Event Facade object with the following attribute specific properties added:
  prevVal
    The value of the attribute, prior to it being set
  newVal
    The value the attribute is to be set to
  attrName
    The name of the attribute being set
  subAttrName
    If setting a property within the attribute's value, the name of the sub-attribute property being set

#### minQueryLengthChange

`minQueryLengthChange ( event )`
Fires when the value for the configuration attribute 'minQueryLength' is changed. You can listen for the event using the on method if you wish to be notified before the attribute's value has changed, or using the after method if you wish to be notified after the attribute's value has changed.

Parameters:
  `event <Event.Facade>` An Event Facade object with the following attribute specific properties added:
  prevVal
    The value of the attribute, prior to it being set
  newVal
    The value the attribute is to be set to
  attrName
    The name of the attribute being set
  subAttrName
    If setting a property within the attribute's value, the name of the sub-attribute property being set

#### query

`query ( e )`
Fires when the contents of the input field have changed and the input value meets the criteria necessary to generate an autocomplete query.

Parameters:
  `e <EventFacade>` Event facade with the following additional properties:
  inputValue (String)
    Full contents of the text input field or textarea that generated the query.
  query (String)
    Autocomplete query. This is the string that will be used to request completion results. It may or may not be the same as `inputValue`.

Preventable: This event is preventable by method e.preventDefault(). The default function executed by this event is _defQueryFn.

#### queryChange

`queryChange ( event )`
Fires when the value for the configuration attribute 'query' is changed. You can listen for the event using the on method if you wish to be notified before the attribute's value has changed, or using the after method if you wish to be notified after the attribute's value has changed.

Parameters:
  `event <Event.Facade>` An Event Facade object with the following attribute specific properties added:
  prevVal
    The value of the attribute, prior to it being set
  newVal
    The value the attribute is to be set to
  attrName
    The name of the attribute being set
  subAttrName
    If setting a property within the attribute's value, the name of the sub-attribute property being set

#### queryDelayChange

`queryDelayChange ( event )`
Fires when the value for the configuration attribute 'queryDelay' is changed. You can listen for the event using the on method if you wish to be notified before the attribute's value has changed, or using the after method if you wish to be notified after the attribute's value has changed.

Parameters:
  `event <Event.Facade>` An Event Facade object with the following attribute specific properties added:
  prevVal
    The value of the attribute, prior to it being set
  newVal
    The value the attribute is to be set to
  attrName
    The name of the attribute being set
  subAttrName
    If setting a property within the attribute's value, the name of the sub-attribute property being set

#### queryDelimiterChange

`queryDelimiterChange ( event )`
Fires when the value for the configuration attribute 'queryDelimiter' is changed. You can listen for the event using the on method if you wish to be notified before the attribute's value has changed, or using the after method if you wish to be notified after the attribute's value has changed.

Parameters:
  `event <Event.Facade>` An Event Facade object with the following attribute specific properties added:
  prevVal
    The value of the attribute, prior to it being set
  newVal
    The value the attribute is to be set to
  attrName
    The name of the attribute being set
  subAttrName
    If setting a property within the attribute's value, the name of the sub-attribute property being set

#### requestTemplateChange

`requestTemplateChange ( event )`
Fires when the value for the configuration attribute 'requestTemplate' is changed. You can listen for the event using the on method if you wish to be notified before the attribute's value has changed, or using the after method if you wish to be notified after the attribute's value has changed.

Parameters:
  `event <Event.Facade>` An Event Facade object with the following attribute specific properties added:
  prevVal
    The value of the attribute, prior to it being set
  newVal
    The value the attribute is to be set to
  attrName
    The name of the attribute being set
  subAttrName
    If setting a property within the attribute's value, the name of the sub-attribute property being set

#### resultFiltersChange

`resultFiltersChange ( event )`
Fires when the value for the configuration attribute 'resultFilters' is changed. You can listen for the event using the on method if you wish to be notified before the attribute's value has changed, or using the after method if you wish to be notified after the attribute's value has changed.

Parameters:
  `event <Event.Facade>` An Event Facade object with the following attribute specific properties added:
  prevVal
    The value of the attribute, prior to it being set
  newVal
    The value the attribute is to be set to
  attrName
    The name of the attribute being set
  subAttrName
    If setting a property within the attribute's value, the name of the sub-attribute property being set

#### resultFormatterChange

`resultFormatterChange ( event )`
Fires when the value for the configuration attribute 'resultFormatter' is changed. You can listen for the event using the on method if you wish to be notified before the attribute's value has changed, or using the after method if you wish to be notified after the attribute's value has changed.

Parameters:
  `event <Event.Facade>` An Event Facade object with the following attribute specific properties added:
  prevVal
    The value of the attribute, prior to it being set
  newVal
    The value the attribute is to be set to
  attrName
    The name of the attribute being set
  subAttrName
    If setting a property within the attribute's value, the name of the sub-attribute property being set

#### resultHighlighterChange

`resultHighlighterChange ( event )`
Fires when the value for the configuration attribute 'resultHighlighter' is changed. You can listen for the event using the on method if you wish to be notified before the attribute's value has changed, or using the after method if you wish to be notified after the attribute's value has changed.

Parameters:
  `event <Event.Facade>` An Event Facade object with the following attribute specific properties added:
  prevVal
    The value of the attribute, prior to it being set
  newVal
    The value the attribute is to be set to
  attrName
    The name of the attribute being set
  subAttrName
    If setting a property within the attribute's value, the name of the sub-attribute property being set

#### resultListLocatorChange

`resultListLocatorChange ( event )`
Fires when the value for the configuration attribute 'resultListLocator' is changed. You can listen for the event using the on method if you wish to be notified before the attribute's value has changed, or using the after method if you wish to be notified after the attribute's value has changed.

Parameters:
  `event <Event.Facade>` An Event Facade object with the following attribute specific properties added:
  prevVal
    The value of the attribute, prior to it being set
  newVal
    The value the attribute is to be set to
  attrName
    The name of the attribute being set
  subAttrName
    If setting a property within the attribute's value, the name of the sub-attribute property being set

#### results

`results ( e )`
Fires after query results are received from the `source`. If no source has been set, this event will not fire.

Parameters:
  `e <EventFacade>` Event facade with the following additional properties:
  data (Array|Object)
    Raw, unfiltered result data (if available).
  query (String)
    Query that generated these results.
  results (Array)
    Array of filtered, formatted, and highlighted results. Each item in the array is an object with the following properties:
    display (Node|HTMLElement|String)
      Formatted result HTML suitable for display to the user. If no custom formatter is set, this will be an HTML-escaped version of the string in the `text` property.
    highlighted (String)
      Highlighted (but not formatted) result text. This property will only be set if a highlighter is in use.
    raw (mixed)
      Raw, unformatted result in whatever form it was provided by the `source`.
    text (String)
      Plain text version of the result, suitable for being inserted into the value of a text input field or textarea when the result is selected by a user. This value is not HTML-escaped and should not be inserted into the page using innerHTML.

Preventable: This event is preventable by method e.preventDefault(). The default function executed by this event is _defResultsFn.

#### resultsChange

`resultsChange ( event )`
Fires when the value for the configuration attribute 'results' is changed. You can listen for the event using the on method if you wish to be notified before the attribute's value has changed, or using the after method if you wish to be notified after the attribute's value has changed.

Parameters:
  `event <Event.Facade>` An Event Facade object with the following attribute specific properties added:
  prevVal
    The value of the attribute, prior to it being set
  newVal
    The value the attribute is to be set to
  attrName
    The name of the attribute being set
  subAttrName
    If setting a property within the attribute's value, the name of the sub-attribute property being set

#### resultTextLocatorChange

`resultTextLocatorChange ( event )`
Fires when the value for the configuration attribute 'resultTextLocator' is changed. You can listen for the event using the on method if you wish to be notified before the attribute's value has changed, or using the after method if you wish to be notified after the attribute's value has changed.

Parameters:
  `event <Event.Facade>` An Event Facade object with the following attribute specific properties added:
  prevVal
    The value of the attribute, prior to it being set
  newVal
    The value the attribute is to be set to
  attrName
    The name of the attribute being set
  subAttrName
    If setting a property within the attribute's value, the name of the sub-attribute property being set

#### sourceChange

`sourceChange ( event )`
Fires when the value for the configuration attribute 'source' is changed. You can listen for the event using the on method if you wish to be notified before the attribute's value has changed, or using the after method if you wish to be notified after the attribute's value has changed.

Parameters:
  `event <Event.Facade>` An Event Facade object with the following attribute specific properties added:
  prevVal
    The value of the attribute, prior to it being set
  newVal
    The value the attribute is to be set to
  attrName
    The name of the attribute being set
  subAttrName
    If setting a property within the attribute's value, the name of the sub-attribute property being set

#### tokenInputChange

`tokenInputChange ( event )`
Fires when the value for the configuration attribute 'tokenInput' is changed. You can listen for the event using the on method if you wish to be notified before the attribute's value has changed, or using the after method if you wish to be notified after the attribute's value has changed.

Parameters:
  `event <Event.Facade>` An Event Facade object with the following attribute specific properties added:
  prevVal
    The value of the attribute, prior to it being set
  newVal
    The value the attribute is to be set to
  attrName
    The name of the attribute being set
  subAttrName
    If setting a property within the attribute's value, the name of the sub-attribute property being set

#### valueChange

`valueChange ( event )`
Fires when the value for the configuration attribute 'value' is changed. You can listen for the event using the on method if you wish to be notified before the attribute's value has changed, or using the after method if you wish to be notified after the attribute's value has changed.

Parameters:
  `event <Event.Facade>` An Event Facade object with the following attribute specific properties added:
  prevVal
    The value of the attribute, prior to it being set
  newVal
    The value the attribute is to be set to
  attrName
    The name of the attribute being set
  subAttrName
    If setting a property within the attribute's value, the name of the sub-attribute property being set

#### yqlEnvChange

`yqlEnvChange ( event )`
Fires when the value for the configuration attribute 'yqlEnv' is changed. You can listen for the event using the on method if you wish to be notified before the attribute's value has changed, or using the after method if you wish to be notified after the attribute's value has changed.

Parameters:
  `event <Event.Facade>` An Event Facade object with the following attribute specific properties added:
  prevVal
    The value of the attribute, prior to it being set
  newVal
    The value the attribute is to be set to
  attrName
    The name of the attribute being set
  subAttrName
    If setting a property within the attribute's value, the name of the sub-attribute property being set

#### yqlProtocolChange

`yqlProtocolChange ( event )`
Fires when the value for the configuration attribute 'yqlProtocol' is changed. You can listen for the event using the on method if you wish to be notified before the attribute's value has changed, or using the after method if you wish to be notified after the attribute's value has changed.

Parameters:
  `event <Event.Facade>` An Event Facade object with the following attribute specific properties added:
  prevVal
    The value of the attribute, prior to it being set
  newVal
    The value the attribute is to be set to
  attrName
    The name of the attribute being set
  subAttrName
    If setting a property within the attribute's value, the name of the sub-attribute property being set

### Configuration Attributes

#### allowBrowserAutocomplete `- Boolean`

Whether or not to enable the browser's built-in autocomplete functionality for input fields.
Default Value: false

#### allowTrailingDelimiter `- Boolean`

When a `queryDelimiter` is set, trailing delimiters will automatically be stripped from the input value by default when the input node loses focus. Set this to `true` to allow trailing delimiters.
Default Value: false

#### inputNode `- writeonce Node|HTMLElement|String`

Node to monitor for changes, which will generate `query` events when appropriate. May be either an input field or a textarea.

#### maxResults `- Number`

Maximum number of results to return. A value of `0` or less will allow an unlimited number of results.
Default Value: 0

#### minQueryLength `- Number`

Minimum number of characters that must be entered before a `query` event will be fired. A value of `0` allows empty queries; a negative value will effectively disable all `query` events.
Default Value: 1

#### query `- String|null`

Current query, or `null` if there is no current query.

The query might not be the same as the current value of the input node, both for timing reasons (due to `queryDelay`) and because when one or more `queryDelimiter` separators are in use, only the last portion of the delimited input string will be used as the query value.

Default Value: null

#### queryDelay `- Number`

Number of milliseconds to delay after input before triggering a `query` event. If new input occurs before this delay is over, the previous input event will be ignored and a new delay will begin.

This can be useful both to throttle queries to a remote data source and to avoid distracting the user by showing them less relevant results before they've paused their typing.

Default Value: 100

#### queryDelimiter `- String|null`

Query delimiter string. When a delimiter is configured, the input value will be split on the delimiter, and only the last portion will be used in autocomplete queries and updated when the `query` attribute is modified.
Default Value: null

#### requestTemplate `- Function|String|null`

Source request template. This can be a function that accepts a query as a parameter and returns a request string, or it can be a string containing the placeholder "{query}", which will be replaced with the actual URI-encoded query. In either case, the resulting string will be appended to the request URL when the `source` attribute is set to a remote DataSource, JSONP URL, or XHR URL (it will not be appended to YQL URLs).

While `requestTemplate` may be set to either a function or a string, it will always be returned as a function that accepts a query argument and returns a string.

Default Value: null

#### resultFilters `- Array`

Array of local result filter functions. If provided, each filter will be called with two arguments when results are received: the query and an array of result objects. See the documentation for the `results` event for a list of the properties available on each result object.

Each filter is expected to return a filtered or modified version of the results array, which will then be passed on to subsequent filters, then the `resultHighlighter` function (if set), then the `resultFormatter` function (if set), and finally to subscribers to the `results` event.

If no `source` is set, result filters will not be called.

Prepackaged result filters provided by the autocomplete-filters and autocomplete-filters-accentfold modules can be used by specifying the filter name as a string, such as `'phraseMatch'` (assuming the necessary filters module is loaded).

Default Value: []

#### resultFormatter `- Function|null`

Function which will be used to format results. If provided, this function will be called with two arguments after results have been received and filtered: the query and an array of result objects. The formatter is expected to return an array of HTML strings or Node instances containing the desired HTML for each result.

See the documentation for the `results` event for a list of the properties available on each result object.

If no `source` is set, the formatter will not be called.

#### resultHighlighter `- Function|null`

Function which will be used to highlight results. If provided, this function will be called with two arguments after results have been received and filtered: the query and an array of filtered result objects. The highlighter is expected to return an array of highlighted result text in the form of HTML strings.

See the documentation for the `results` event for a list of the properties available on each result object.

If no `source` is set, the highlighter will not be called.

#### resultListLocator `- Function|String|null`

Locator that should be used to extract an array of results from a non-array response.

By default, no locator is applied, and all responses are assumed to be arrays by default. If all responses are already arrays, you don't need to define a locator.

The locator may be either a function (which will receive the raw response as an argument and must return an array) or a string representing an object path, such as "foo.bar.baz" (which would return the value of `result.foo.bar.baz` if the response is an object).

While `resultListLocator` may be set to either a function or a string, it will always be returned as a function that accepts a response argument and returns an array.

#### results `- Array`

Current results, or an empty array if there are no results.
Default Value: []

#### resultTextLocator `- Function|String|null`

Locator that should be used to extract a plain text string from a non-string result item. The resulting text value will typically be the value that ends up being inserted into an input field or textarea when the user of an autocomplete implementation selects a result.

By default, no locator is applied, and all results are assumed to be plain text strings. If all results are already plain text strings, you don't need to define a locator.

The locator may be either a function (which will receive the raw result as an argument and must return a string) or a string representing an object path, such as "foo.bar.baz" (which would return the value of `result.foo.bar.baz` if the result is an object).

While `resultTextLocator` may be set to either a function or a string, it will always be returned as a function that accepts a result argument and returns a string.

#### source `- Array|DataSource|Function|Object|String|null`

Source for autocomplete results. The following source types are supported:

Array

  Example: `['first result', 'second result', 'etc']`

  The full array will be provided to any configured filters for each query. This is an easy way to create a fully client-side autocomplete implementation.

DataSource

  A `DataSource` instance or other object that provides a DataSource-like `sendRequest` method. See the `DataSource` documentation for details.

Function

  Example: `function (query) { return ['foo', 'bar']; }`

  A function source will be called with the current query as a parameter, and should return an array of results.

Object

  Example: `{foo: ['foo result 1', 'foo result 2'], bar: ['bar result']}`

  An object will be treated as a query hashmap. If a property on the object matches the current query, the value of that property will be used as the response.

  The response is assumed to be an array of results by default. If the response is not an array, provide a `resultListLocator` to process the response and return an array.

If the optional `autocomplete-sources` module is loaded, then the following additional source types will be supported as well:

String (JSONP URL)

  Example: `'http://example.com/search?q={query}&callback={callback}'`

  If a URL with a `{callback}` placeholder is provided, it will be used to make a JSONP request. The `{query}` placeholder will be replaced with the current query, and the `{callback}` placeholder will be replaced with an internally-generated JSONP callback name. Both placeholders must appear in the URL, or the request will fail. An optional `{maxResults}` placeholder may also be provided, and will be replaced with the value of the maxResults attribute (or 1000 if the maxResults attribute is 0 or less).

  The response is assumed to be an array of results by default. If the response is not an array, provide a `resultListLocator` to process the response and return an array.

  The `jsonp` module must be loaded in order for JSONP URL sources to work. If the `jsonp` module is not already loaded, it will be loaded on demand if possible.

String (XHR URL)

  Example: `'http://example.com/search?q={query}'`

  If a URL without a `{callback}` placeholder is provided, it will be used to make a same-origin XHR request. The `{query}` placeholder will be replaced with the current query. An optional `{maxResults}` placeholder may also be provided, and will be replaced with the value of the maxResults attribute (or 1000 if the maxResults attribute is 0 or less).

  The response is assumed to be a JSON array of results by default. If the response is a JSON object and not an array, provide a `resultListLocator` to process the response and return an array. If the response is in some form other than JSON, you will need to use a custom DataSource instance as the source.

  The `io-base` and `json-parse` modules must be loaded in order for XHR URL sources to work. If these modules are not already loaded, they will be loaded on demand if possible.

String (YQL query)

  Example: `'select * from search.suggest where query="{query}"'`

  If a YQL query is provided, it will be used to make a YQL request. The `{query}` placeholder will be replaced with the current autocomplete query. This placeholder must appear in the YQL query, or the request will fail. An optional `{maxResults}` placeholder may also be provided, and will be replaced with the value of the maxResults attribute (or 1000 if the maxResults attribute is 0 or less).

  The `yql` module must be loaded in order for YQL sources to work. If the `yql` module is not already loaded, it will be loaded on demand if possible.

As an alternative to providing a source, you could simply listen for `query` events and handle them any way you see fit. Providing a source is optional, but will usually be simpler.

#### tokenInput `- Plugin.TokenInput`

If the `inputNode` specified at instantiation time has a `node-tokeninput` plugin attached to it, this attribute will be a reference to the `Y.Plugin.TokenInput` instance.

#### value `- String`

Current value of the input node.
Default Value: ''

#### yqlEnv `- String`

YQL environment file URL to load when the `source` is set to a YQL query. Set this to `null` to use the default Open Data Tables environment file (http://datatables.org/alltables.env).
Default Value: null

#### yqlProtocol `- String`

URL protocol to use when the `source` is set to a YQL query.
Default Value: 'http'

Copyright © 2011 Yahoo! Inc. All rights reserved.